#include "wrapper.h"
#include "sockinfo.h"

int is_active(active_setp asp,int s)
{
	int active = 0;
	active = dfd_isset(s, &asp->act_set);
	return active;
}


void init_active_set(active_setp asp)
{
	asp->act_set_max = 0;
	dfd_init(&asp->act_set, 32);
	return ;
}

void finalize_active_set(active_setp asp)
{
	dfd_finalize(&asp->act_set);
	asp->act_set_max = 0;
	return;
}

int set_active(active_setp asp, int s)
{
	dfd_set(s, &asp->act_set);
	if (s >= asp->act_set_max) {
		asp->act_set_max = s+1;
	}
	return(1);
}

int clr_active(active_setp asp, int s)
{
	dfd_clr(s, &asp->act_set);
	if (s+1 >= asp->act_set_max) /* need to reduce act_set_max */ {
		int i;
		for (i=s; i >= 0; i--) if (dfd_isset(i, &asp->act_set)) break;
		asp->act_set_max = i+1;
	}
	return(1);
}


/*
 * Local variables:
 *  c-indent-level: 3
 *  c-basic-offset: 3
 *  tab-width: 3
 * End:
 *
 * vim: ts=3
 */
